# Interface IResourceChangeEvent

public interface IResourceChangeEvent
Resource change events describe changes to resources.

The following types of resource change events are reported:

- Before-the-fact batch reports of arbitrary creations, deletions and modifications to one or more resources expressed as a hierarchical resource delta. Event type is `PRE_BUILD`, and `getDelta` returns the hierarchical delta rooted at the workspace root. The `getBuildKind` method returns the kind of build that is about to occur, and the `getSource` method returns the scope of the build (either the workspace or a single project). These events are broadcast to interested parties immediately before each build operation. If autobuilding is not enabled, these events still occur at times when autobuild would have occurred. The workspace is open for change during notification of these events. The delta reported in this event cycle is identical across all listeners registered for this type of event. Resource changes attempted during a `PRE_BUILD` callback must be done in the thread doing the notification.
- After-the-fact batch reports of arbitrary creations, deletions and modifications to one or more resources expressed as a hierarchical resource delta. Event type is `POST_BUILD`, and `getDelta` returns the hierarchical delta rooted at the workspace root. The `getBuildKind` method returns the kind of build that occurred, and the `getSource` method returns the scope of the build (either the workspace or a single project). These events are broadcast to interested parties at the end of every build operation. If autobuilding is not enabled, these events still occur at times when autobuild would have occurred. The workspace is open for change during notification of these events. The delta reported in this event cycle is identical across all listeners registered for this type of event. Resource changes attempted during a `POST_BUILD` callback must be done in the thread doing the notification.
- After-the-fact batch reports of arbitrary creations, deletions and modifications to one or more resources expressed as a hierarchical resource delta. Event type is `POST_CHANGE`, and `getDelta` returns the hierarchical delta. The resource delta is rooted at the workspace root. These events are broadcast to interested parties after a set of resource changes and happen whether or not autobuilding is enabled. The workspace is closed for change during notification of these events. The delta reported in this event cycle is identical across all listeners registered for this type of event.
- Before-the-fact reports of the impending closure of a single project. Event type is `PRE_CLOSE`, and `getResource` returns the project being closed. The workspace is closed for change during notification of these events.
- Before-the-fact reports of the impending deletion of a single project. Event type is `PRE_DELETE`, and `getResource` returns the project being deleted. The workspace is closed for change during notification of these events.
- Before-the-fact reports of the impending refresh of a single project or the workspace. Event type is `PRE_REFRESH` and the `getSource` method returns the scope of the refresh (either the workspace or a single project). If the event is fired by a project refresh the `getResource` method returns the project being refreshed. The workspace is closed for changes during notification of these events.

In order to handle additional event types that may be introduced in future releases of the platform, clients should do not write code that presumes the set of event types is closed.

Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`POST_AUTO_BUILD`
Deprecated.
This event type has been renamed to `POST_BUILD`
`static final int`
`POST_BUILD`
Event type constant (bit mask) indicating an after-the-fact report of a build.
`static final int`
`POST_CHANGE`
Event type constant (bit mask) indicating an after-the-fact report of creations, deletions, and modifications to one or more resources expressed as a hierarchical resource delta as returned by `getDelta`.
`static final int`
`PRE_AUTO_BUILD`
Deprecated.
This event type has been renamed to `PRE_BUILD`
`static final int`
`PRE_BUILD`
Event type constant (bit mask) indicating a before-the-fact report of a build.
`static final int`
`PRE_CLOSE`
Event type constant (bit mask) indicating a before-the-fact report of the impending closure of a single project as returned by `getResource`.
`static final int`
`PRE_DELETE`
Event type constant (bit mask) indicating a before-the-fact report of the impending deletion of a single project as returned by `getResource`.
`static final int`
`PRE_REFRESH`
Event type constant (bit mask) indicating a before-the-fact report of refreshing the workspace or a project.

## Method Summary

Modifier and Type
Method
Description
`IMarkerDelta[]`
`findMarkerDeltas(String type, boolean includeSubtypes)`
Returns all marker deltas of the specified type that are associated with resource deltas for this event.
`int`
`getBuildKind()`
Returns the kind of build that caused this event, or `0` if not applicable to this type of event.
`IResourceDelta`
`getDelta()`
Returns a resource delta, rooted at the workspace, describing the set of changes that happened to resources in the workspace.
`IResource`
`getResource()`
Returns the resource in question or `null` if not applicable to this type of event.
`Object`
`getSource()`
Returns an object identifying the source of this event.
`int`
`getType()`
Returns the type of event being reported.

## Field Details

### POST_CHANGE

static final int POST_CHANGE
Event type constant (bit mask) indicating an after-the-fact report of creations, deletions, and modifications to one or more resources expressed as a hierarchical resource delta as returned by `getDelta`. See class comments for further details.

See Also:
  - `getType()`
  - `getDelta()`
  - Constant Field Values

### PRE_CLOSE

static final int PRE_CLOSE
Event type constant (bit mask) indicating a before-the-fact report of the impending closure of a single project as returned by `getResource`. See class comments for further details.

See Also:
  - `getType()`
  - `getResource()`
  - Constant Field Values

### PRE_DELETE

static final int PRE_DELETE
Event type constant (bit mask) indicating a before-the-fact report of the impending deletion of a single project as returned by `getResource`. See class comments for further details.

See Also:
  - `getType()`
  - `getResource()`
  - Constant Field Values

### PRE_AUTO_BUILD

@Deprecated static final int PRE_AUTO_BUILD
Deprecated.
This event type has been renamed to `PRE_BUILD`

See Also:
  - Constant Field Values

### PRE_BUILD

static final int PRE_BUILD
Event type constant (bit mask) indicating a before-the-fact report of a build. The event contains a hierarchical resource delta as returned by `getDelta`. See class comments for further details.

Since:
  3.0
See Also:
  - `getBuildKind()`
  - `getSource()`
  - Constant Field Values

### POST_AUTO_BUILD

@Deprecated static final int POST_AUTO_BUILD
Deprecated.
This event type has been renamed to `POST_BUILD`

See Also:
  - Constant Field Values

### POST_BUILD

static final int POST_BUILD
Event type constant (bit mask) indicating an after-the-fact report of a build. The event contains a hierarchical resource delta as returned by `getDelta`. See class comments for further details.

Since:
  3.0
See Also:
  - `getBuildKind()`
  - `getSource()`
  - Constant Field Values

### PRE_REFRESH

static final int PRE_REFRESH
Event type constant (bit mask) indicating a before-the-fact report of refreshing the workspace or a project. See class comments for further details.

Since:
  3.4
See Also:
  - `getType()`
  - `getSource()`
  - `getResource()`
  - Constant Field Values

## Method Details

### findMarkerDeltas

IMarkerDelta[] findMarkerDeltas(String type, boolean includeSubtypes)
Returns all marker deltas of the specified type that are associated with resource deltas for this event. If `includeSubtypes` is `false`, only marker deltas whose type exactly matches the given type are returned. Returns an empty array if there are no matching marker deltas.

Calling this method is equivalent to walking the entire resource delta for this event, and collecting all marker deltas of a given type. The speed of this method will be proportional to the number of changed markers, regardless of the size of the resource delta tree.

Parameters:
  `type` - the type of marker to consider, or `null` to indicate all types
  `includeSubtypes` - whether or not to consider sub-types of the given type
Returns:
  an array of marker deltas
Since:
  2.0

### getBuildKind

int getBuildKind()
Returns the kind of build that caused this event, or `0` if not applicable to this type of event.

If the event is a `PRE_BUILD` or `POST_BUILD` then this will be the kind of build that occurred to cause the event.

Returns:
  the kind of build, or `0` if not applicable
Since:
  3.1
See Also:
  - `IProject.build(int, IProgressMonitor)`
  - `IWorkspace.build(int, IProgressMonitor)`
  - `IncrementalProjectBuilder.AUTO_BUILD`
  - `IncrementalProjectBuilder.FULL_BUILD`
  - `IncrementalProjectBuilder.INCREMENTAL_BUILD`
  - `IncrementalProjectBuilder.CLEAN_BUILD`

### getDelta

IResourceDelta getDelta()
Returns a resource delta, rooted at the workspace, describing the set of changes that happened to resources in the workspace. Returns `null` if not applicable to this type of event.

Returns:
  the resource delta, or `null` if not applicable

### getResource

IResource getResource()
Returns the resource in question or `null` if not applicable to this type of event.

If the event is of type `PRE_CLOSE`, `PRE_DELETE`, or `PRE_REFRESH`, then the resource will be the affected project. Otherwise the resource will be `null`.

Returns:
  the resource, or `null` if not applicable

### getSource

Object getSource()
Returns an object identifying the source of this event.

If the event is a `PRE_BUILD`, `POST_BUILD`, or `PRE_REFRESH` then this will be the scope of the build (either the `IWorkspace` or a single `IProject`).

Returns:
  an object identifying the source of this event
See Also:
  - `EventObject`

### getType

int getType()
Returns the type of event being reported.

Returns:
  one of the event type constants
See Also:
  - `POST_CHANGE`
  - `POST_BUILD`
  - `PRE_BUILD`
  - `PRE_CLOSE`
  - `PRE_DELETE`
  - `PRE_REFRESH`